/**
 * @author Rafi Ton (rafi.ton@casual-mobile.com)
 */

var help = "Welcome to Button Mania!  The objective of the game is to set all buttons to '0'. Click on one of the buttons in the playing field to decrement that button's value by 1, as well as the values of the 4 surrounding ones.   Good Luck!!";
var about = "Button Mania v1.0 for Nokia WRT by casual-mobile.com - all rights reserved (c) 2010.";

var loc = '';
var adText = '';
var currentTime = (new Date()).getTime();
try { 
	netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
} catch(e) {
	
} 
$.post("http://woofeed.com/wrt/getIpAddr.wrt.php", {
	time: currentTime
	}, function(myloc) {
	loc = myloc;
});

function create_ad_server_user_id () {
	var key='';
	var pos=0;
	var pattern = "1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
	for(var i=0; i<80; i=i+1) {
		pos = Math.floor(Math.random()*61) - 1;
		key = key + pattern.charAt(pos);
	}
	return key;
}

function loadRandomBackground() {
	var bg = 'bg'+Math.floor(Math.random()*3+1)+'.jpg';
	$("body").css('background','url('+bg+')');
}

var ad_server_user_id = widget.preferenceForKey("ad_server_user_id");

if (ad_server_user_id===undefined) {
	ad_server_user_id=create_ad_server_user_id();
	widget.setPreferenceForKey(ad_server_user_id, "ad_server_user_id");
} 


function init() {
	loadRandomBackground();
	//create about menu
	var newGameMenuItem = new MenuItem("New Game", 500);
	newGameMenuItem.onSelect = menuItemSelected;
	menu.append(newGameMenuItem);
	
	var restartGameMenuItem = new MenuItem("Restart Game", 700);
	restartGameMenuItem.onSelect = menuItemSelected;
	menu.append(restartGameMenuItem);	
	
	var aboutMenuItem = new MenuItem("About", 1000);
	aboutMenuItem.onSelect = menuItemSelected;
	menu.append(aboutMenuItem);
	
	var helpMenuItem = new MenuItem("Help", 2000);
	helpMenuItem.onSelect = menuItemSelected;
	menu.append(helpMenuItem);	
	
    // set tab-navigation mode and show softkeys
    // (only if we are in the WRT environment)
    if (window.widget) {
        widget.setNavigationEnabled(false);
        menu.showSoftkeys();
    }
	
	$("#splash").html('<center><img src="loader.gif" style="margin-top:100px" /></enter>');

	try { 
		netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
	} catch(e) {
		
	}
	
	$.post("http://woofeed.com/adEngine/dispatch.do.php", {
		loc: loc,
		origin: 'button mania',
		client_type: 'wrt',
		ad_type: 'large rectangle',
		keywords: '',
		user_id: ad_server_user_id,
		action: 'loaded',
		zone: '#splash',
		time: currentTime
	}, function(ad) {
		if (ad=='') {
			showSplash = "<img src='images/woofeed_splash_340.png' style='margin-top:30px' /><br /><img src='images/splash-loader.gif' /><br />";
		} else {
			currentTime = (new Date()).getTime();
			ad = ad.replace(/INSERT_RANDOM_NUMBER_HERE/g, currentTime);
			showSplash = ad;
		}
		$("#splash").html('<h3>-- Advertisement --</h3>'+showSplash);
	});
	
	$("#splash").css('margin-top', '0');
	$("#splash").show();
	setTimeout("NewGame()", 7000);
}

function menuItemSelected(id) {
    switch (id) {
		case 500:
			NewGame();
			break;
		case 700:
			TakeBack(-1);
			getBanners();
			break;
       	case 1000:
			alert(about);
			getBanners();
			break;
       	case 2000:
			alert(help);
			getBanners();
			break;			
    }
}

var Size = new Number(6);
var Moves = new Array();

function NewGame() {
	$("#splash").hide();
	$("#game").show();
	$(".element").show();
	getBanners();
	for(i = 0; i < Size * Size; document.forms[0].elements[i++].value = 0);
	for(i = 0; i < 3 + 3 * document.forms[0].Difficulty.selectedIndex; i++)
	NewValue(Math.floor(Math.random() * Size),Math.floor(Math.random() * Size),1);
	Moves.length = document.forms[0].Score.value = 0;
}

function TakeBack(flag) {
	while(flag-- && (i = Moves.pop()))
	NewValue(parseInt(i.split("-")[0]),parseInt(i.split("-")[1]),1);
	document.forms[0].Score.value = Moves.length;
}

function Clicked(x,y) {
	NewValue(x,y,3);
	document.forms[0].Score.value = Moves.push(x + "-" + y);
	for(i = 0; i < Size * Size; i++)
		if(parseInt(document.forms[0].elements[i].value))
			return;
	alert((Moves.length <= 3 + 3 * document.forms[0].Difficulty.selectedIndex ? "Perfect!\n" : "") + "Done in " + Moves.length + " clicks");
	NewGame();
}

function NewValue(x,y,c) {
	ChangeValue(x,y,c);
	ChangeValue(x - 1,y,c);
	ChangeValue(x + 1,y,c);
	ChangeValue(x,y - 1,c);
	ChangeValue(x,y + 1,c);
}

function ChangeValue(x,y,c) {
	if(x >= 0 && x < Size && y >= 0 && y < Size)
		with(document.forms[0].elements[x + Size * y]) value = (parseInt(value) + c) & 3;
}

$(".adk_link").live("click", function () {
	var adk = $(this).attr("adk");
	var zone = $(this).parent().attr('id');
	
	try { 
		netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
	} catch(e) {
		
	}
	
	$.post("http://woofeed.com/adEngine/updateClick.do.php", {
		origin: 'button_mania',
		client_type: 'wrt',
		ad_id: 0,
		user_id: ad_server_user_id,
		adk: adk,
		zone: zone,
		action: 'clicked'
	});
	
	var open_url = $(this).attr("href");
	var open_url_enc = encodeURI(open_url);
	widget.openURL(open_url_enc);
	return false;
});	

function getSmallBannerAd(div_id) {
	currentTime = (new Date()).getTime();

	try { 
		netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
	} catch(e) {
		
	}
	
	$.post("http://woofeed.com/adEngine/dispatch.do.php", {
		loc: loc,
		origin: 'button mania',
		client_type: 'wrt',
		ad_type: 'button 2',
		keywords: '',
		zone: div_id,
		action: 'loaded',
		user_id: ad_server_user_id,
		time: currentTime
	}, function(ad) {
		currentTime = (new Date()).getTime();
		ad = ad.replace(/INSERT_RANDOM_NUMBER_HERE/g, currentTime);
		$(div_id).html(ad);
	});
}

function getBanners() {
	getSmallBannerAd("#banner1");
	getSmallBannerAd("#banner2");
	getSmallBannerAd("#banner3");
}
